# -*- coding: utf-8 -*-
# Generated by Django 1.11 on 2018-05-22 05:48
from __future__ import unicode_literals

import datetime
import dirtyfields.dirtyfields
from django.db import migrations, models
import django.db.models.deletion
import members.countryfield
import members.models
from django.apps import apps as global_apps


def forward(apps, _):

    ContentType = apps.get_model('contenttypes', 'ContentType')

    Member_old = apps.get_model('members', 'Member')
    Member_new = apps.get_model('members', 'Member_new')

    # Use Member_old here because "Member_new" will be renamed to "Member" right after migration of the data
    new_member_ct = ContentType.objects.get_for_model(Member_old).id

    for old_member in Member_old.objects.all():
        new_member = Member_new()

        new_member._imported = True
        new_member.polymorphic_ctype_id = new_member_ct

        new_member.chaos_number = old_member.chaos_number
        new_member.membership_type = old_member.membership_type
        new_member.is_active = old_member.is_active
        new_member.membership_reduced = old_member.membership_reduced
        new_member.erfa = old_member.erfa
        new_member.first_name = old_member.first_name
        new_member.last_name = old_member.last_name
        new_member.address_1 = old_member.address_1
        new_member.address_2 = old_member.address_2
        new_member.address_3 = old_member.address_3
        new_member.address_country = old_member.address_country
        new_member.address_unknown = old_member.address_unknown
        new_member.membership_start = old_member.membership_start
        new_member.membership_end = old_member.membership_end
        new_member.fee_last_paid = old_member.fee_last_paid
        new_member.fee_paid_until = old_member.fee_paid_until
        new_member.last_update = old_member.last_update
        new_member.account_balance = old_member.account_balance
        new_member.fee_override = old_member.fee_override
        new_member.fee_registration_paid = old_member.fee_registration_paid
        new_member.comment = old_member.comment

        new_member.save()

    try:
        Subscriber_old = apps.get_model('datenschleuder', 'Subscriber')
    except LookupError:
        # datenschleuder app isn't installed, no migration necessary
        return

    Subscriber_new = apps.get_model('members', 'Subscriber')
    subscriber_ct = ContentType.objects.get_for_model(Subscriber_new).id

    for old_subscriber in Subscriber_old.objects.all():
        # This filters Datenschleuder subscribers, who have the same chaos_number as an already existing member
        # These doublicates usually stem from moving a subscriber to the member database without deleting it from
        # the subscriber database
        if Member_new.objects.filter(chaos_number=old_subscriber.datenschleuder_number).exists():
            continue

        new_subscriber = Subscriber_new()

        new_subscriber._imported = True
        new_subscriber.polymorphic_ctype_id = subscriber_ct

        new_subscriber.chaos_number = old_subscriber.datenschleuder_number
        new_subscriber.subscriber_source = old_subscriber.subscriber_source
        new_subscriber.first_name = old_subscriber.first_name
        new_subscriber.last_name = old_subscriber.last_name
        new_subscriber.address_1 = old_subscriber.address_1
        new_subscriber.address_2 = old_subscriber.address_2
        new_subscriber.address_3 = old_subscriber.address_3
        new_subscriber.address_country = old_subscriber.address_country
        new_subscriber.address_unknown = old_subscriber.address_unknown
        new_subscriber.max_datenschleuder_issue = old_subscriber.max_datenschleuder_issue
        new_subscriber.is_endless = old_subscriber.is_endless
        new_subscriber.rt_link = old_subscriber.rt_link

        new_subscriber.save()


def backward(apps, _):
    Member_old = apps.get_model('members', 'Member')
    Member_new = apps.get_model('members', 'Member_new')

    for new_member in Member_new.objects.all():
        old_member = Member_old()

        old_member._imported = True

        old_member.chaos_number = new_member.chaos_number
        old_member.membership_type = new_member.membership_type
        old_member.is_active = new_member.is_active
        old_member.membership_reduced = new_member.membership_reduced
        old_member.erfa = new_member.erfa
        old_member.first_name = new_member.first_name
        old_member.last_name = new_member.last_name
        old_member.address_1 = new_member.address_1
        old_member.address_2 = new_member.address_2
        old_member.address_3 = new_member.address_3
        old_member.address_country = new_member.address_country
        old_member.address_unknown = new_member.address_unknown
        old_member.membership_start = new_member.membership_start
        old_member.membership_end = new_member.membership_end
        old_member.fee_last_paid = new_member.fee_last_paid
        old_member.fee_paid_until = new_member.fee_paid_until
        old_member.last_update = new_member.last_update
        old_member.account_balance = new_member.account_balance
        old_member.fee_override = new_member.fee_override
        old_member.fee_registration_paid = new_member.fee_registration_paid
        old_member.comment = new_member.comment

        old_member.save()

    try:
        Subscriber_old = apps.get_model('datenschleuder', 'Subscriber')
    except LookupError:
        # datenschleuder app isn't installed, no migration necessary
        return

    Subscriber_new = apps.get_model('members', 'Subscriber')

    for new_subscriber in Subscriber_new.objects.all():
        old_subscriber, created = Subscriber_old.objects.get_or_create(
            datenschleuder_number=new_subscriber.chaos_number,
            subscriber_source=new_subscriber.subscriber_source,
            first_name=new_subscriber.first_name,
            last_name=new_subscriber.last_name,
            address_1=new_subscriber.address_1,
            address_2=new_subscriber.address_2,
            address_3=new_subscriber.address_3,
            address_country=new_subscriber.address_country,
            address_unknown=new_subscriber.address_unknown,
            max_datenschleuder_issue=new_subscriber.max_datenschleuder_issue,
            is_endless=new_subscriber.is_endless,
            rt_link=new_subscriber.rt_link,
        )

        if created:
            old_subscriber._imported = True
            old_subscriber.save()


class Migration(migrations.Migration):

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
        ('members', '0025_auto_20180517_1640'),
    ]

    operations = [
        migrations.CreateModel(
            name='Person',
            fields=[
                ('chaos_number', models.AutoField(primary_key=True, serialize=False)),
                ('first_name', models.CharField(max_length=255)),
                ('last_name', models.CharField(max_length=255)),
                ('address_1', models.CharField(max_length=255)),
                ('address_2', models.CharField(blank=True, max_length=255, null=True)),
                ('address_3', models.CharField(blank=True, max_length=255, null=True)),
                ('address_country', members.countryfield.CountryField(choices=[('', 'None'), ('DE', 'Germany'), ('AT', 'Austria'), ('CH', 'Switzerland'), ('AD', 'Andorra'), ('AE', 'United Arab Emirates'), ('AF', 'Afghanistan'), ('AG', 'Antigua and Barbuda'), ('AI', 'Anguilla'), ('AL', 'Albania'), ('AM', 'Armenia'), ('AN', 'Netherlands Antilles'), ('AO', 'Angola'), ('AQ', 'Antarctica'), ('AR', 'Argentina'), ('AS', 'American Samoa'), ('AU', 'Australia'), ('AW', 'Aruba'), ('AZ', 'Azerbaijan'), ('BA', 'Bosnia and Herzegovina'), ('BB', 'Barbados'), ('BD', 'Bangladesh'), ('BE', 'Belgium'), ('BF', 'Burkina Faso'), ('BG', 'Bulgaria'), ('BH', 'Bahrain'), ('BI', 'Burundi'), ('BJ', 'Benin'), ('BM', 'Bermuda'), ('BN', 'Brunei Darussalam'), ('BO', 'Bolivia'), ('BR', 'Brazil'), ('BS', 'Bahama'), ('BT', 'Bhutan'), ('BV', 'Bouvet Island'), ('BW', 'Botswana'), ('BY', 'Belarus'), ('BZ', 'Belize'), ('CA', 'Canada'), ('CC', 'Cocos (Keeling) Islands'), ('CF', 'Central African Republic'), ('CG', 'Congo'), ('CI', 'Ivory Coast'), ('CK', 'Cook Iislands'), ('CL', 'Chile'), ('CM', 'Cameroon'), ('CN', 'China'), ('CO', 'Colombia'), ('CR', 'Costa Rica'), ('CU', 'Cuba'), ('CV', 'Cape Verde'), ('CX', 'Christmas Island'), ('CY', 'Cyprus'), ('CZ', 'Czech Republic'), ('DJ', 'Djibouti'), ('DK', 'Denmark'), ('DM', 'Dominica'), ('DO', 'Dominican Republic'), ('DZ', 'Algeria'), ('EC', 'Ecuador'), ('EE', 'Estonia'), ('EG', 'Egypt'), ('EH', 'Western Sahara'), ('ER', 'Eritrea'), ('ES', 'Spain'), ('ET', 'Ethiopia'), ('FI', 'Finland'), ('FJ', 'Fiji'), ('FK', 'Falkland Islands (Malvinas)'), ('FM', 'Micronesia'), ('FO', 'Faroe Islands'), ('FR', 'France'), ('FX', 'France, Metropolitan'), ('GA', 'Gabon'), ('GB', 'United Kingdom (Great Britain)'), ('GD', 'Grenada'), ('GE', 'Georgia'), ('GF', 'French Guiana'), ('GH', 'Ghana'), ('GI', 'Gibraltar'), ('GL', 'Greenland'), ('GM', 'Gambia'), ('GN', 'Guinea'), ('GP', 'Guadeloupe'), ('GQ', 'Equatorial Guinea'), ('GR', 'Greece'), ('GS', 'South Georgia and the South Sandwich Islands'), ('GT', 'Guatemala'), ('GU', 'Guam'), ('GW', 'Guinea-Bissau'), ('GY', 'Guyana'), ('HK', 'Hong Kong'), ('HM', 'Heard and McDonald Islands'), ('HN', 'Honduras'), ('HR', 'Croatia'), ('HT', 'Haiti'), ('HU', 'Hungary'), ('ID', 'Indonesia'), ('IE', 'Ireland'), ('IL', 'Israel'), ('IN', 'India'), ('IO', 'British Indian Ocean Territory'), ('IQ', 'Iraq'), ('IR', 'Islamic Republic of Iran'), ('IS', 'Iceland'), ('IT', 'Italy'), ('JM', 'Jamaica'), ('JO', 'Jordan'), ('JP', 'Japan'), ('KE', 'Kenya'), ('KG', 'Kyrgyzstan'), ('KH', 'Cambodia'), ('KI', 'Kiribati'), ('KM', 'Comoros'), ('KN', 'St. Kitts and Nevis'), ('KP', "Korea, Democratic People's Republic of"), ('KR', 'Korea, Republic of'), ('KW', 'Kuwait'), ('KY', 'Cayman Islands'), ('KZ', 'Kazakhstan'), ('LA', "Lao People's Democratic Republic"), ('LB', 'Lebanon'), ('LC', 'Saint Lucia'), ('LI', 'Liechtenstein'), ('LK', 'Sri Lanka'), ('LR', 'Liberia'), ('LS', 'Lesotho'), ('LT', 'Lithuania'), ('LU', 'Luxembourg'), ('LV', 'Latvia'), ('LY', 'Libyan Arab Jamahiriya'), ('MA', 'Morocco'), ('MC', 'Monaco'), ('MD', 'Moldova, Republic of'), ('MG', 'Madagascar'), ('MH', 'Marshall Islands'), ('ML', 'Mali'), ('MN', 'Mongolia'), ('MM', 'Myanmar'), ('MO', 'Macau'), ('MP', 'Northern Mariana Islands'), ('MQ', 'Martinique'), ('MR', 'Mauritania'), ('MS', 'Monserrat'), ('MT', 'Malta'), ('MU', 'Mauritius'), ('MV', 'Maldives'), ('MW', 'Malawi'), ('MX', 'Mexico'), ('MY', 'Malaysia'), ('MZ', 'Mozambique'), ('NA', 'Namibia'), ('NC', 'New Caledonia'), ('NE', 'Niger'), ('NF', 'Norfolk Island'), ('NG', 'Nigeria'), ('NI', 'Nicaragua'), ('NL', 'Netherlands'), ('NO', 'Norway'), ('NP', 'Nepal'), ('NR', 'Nauru'), ('NU', 'Niue'), ('NZ', 'New Zealand'), ('OM', 'Oman'), ('PA', 'Panama'), ('PE', 'Peru'), ('PF', 'French Polynesia'), ('PG', 'Papua New Guinea'), ('PH', 'Philippines'), ('PK', 'Pakistan'), ('PL', 'Poland'), ('PM', 'St. Pierre and Miquelon'), ('PN', 'Pitcairn'), ('PR', 'Puerto Rico'), ('PT', 'Portugal'), ('PW', 'Palau'), ('PY', 'Paraguay'), ('QA', 'Qatar'), ('RE', 'Reunion'), ('RO', 'Romania'), ('RU', 'Russian Federation'), ('RS', 'Serbia'), ('RW', 'Rwanda'), ('SA', 'Saudi Arabia'), ('SB', 'Solomon Islands'), ('SC', 'Seychelles'), ('SD', 'Sudan'), ('SE', 'Sweden'), ('SG', 'Singapore'), ('SH', 'St. Helena'), ('SI', 'Slovenia'), ('SJ', 'Svalbard and Jan Mayen Islands'), ('SK', 'Slovakia'), ('SL', 'Sierra Leone'), ('SM', 'San Marino'), ('SN', 'Senegal'), ('SO', 'Somalia'), ('SR', 'Suriname'), ('ST', 'Sao Tome and Principe'), ('SV', 'El Salvador'), ('SY', 'Syrian Arab Republic'), ('SZ', 'Swaziland'), ('TC', 'Turks and Caicos Islands'), ('TD', 'Chad'), ('TF', 'French Southern Territories'), ('TG', 'Togo'), ('TH', 'Thailand'), ('TJ', 'Tajikistan'), ('TK', 'Tokelau'), ('TM', 'Turkmenistan'), ('TN', 'Tunisia'), ('TO', 'Tonga'), ('TP', 'East Timor'), ('TR', 'Turkey'), ('TT', 'Trinidad and Tobago'), ('TV', 'Tuvalu'), ('TW', 'Taiwan, Province of China'), ('TZ', 'Tanzania, United Republic of'), ('UA', 'Ukraine'), ('UG', 'Uganda'), ('UM', 'United States Minor Outlying Islands'), ('US', 'United States of America'), ('UY', 'Uruguay'), ('UZ', 'Uzbekistan'), ('VA', 'Vatican City State (Holy See)'), ('VC', 'St. Vincent and the Grenadines'), ('VE', 'Venezuela'), ('VG', 'British Virgin Islands'), ('VI', 'United States Virgin Islands'), ('VN', 'Viet Nam'), ('VU', 'Vanuatu'), ('WF', 'Wallis and Futuna Islands'), ('WS', 'Samoa'), ('YE', 'Yemen'), ('YT', 'Mayotte'), ('YU', 'Yugoslavia'), ('ZA', 'South Africa'), ('ZM', 'Zambia'), ('ZR', 'Zaire'), ('ZW', 'Zimbabwe'), ('ZZ', 'Unknown or unspecified country')], default='DE', max_length=2)),
                ('address_unknown', models.BooleanField(default=False)),
            ],
            options={
                'manager_inheritance_from_future': True,
            },
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='Member_new',
            fields=[
                ('person_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='members.Person')),
                ('membership_type', models.CharField(choices=[('SUP', 'SUPPORTER'), ('MBR', 'MEMBER'), ('HON', 'HONORARY')], default='SUP', max_length=3)),
                ('is_active', models.BooleanField(default=True)),
                ('membership_reduced', models.BooleanField(default=False)),
                ('membership_start', models.DateField(default=datetime.date.today)),
                ('membership_end', models.DateField(blank=True, null=True)),
                ('fee_last_paid', models.DateField(default=datetime.date.today)),
                ('fee_paid_until', models.DateField(default=datetime.date.today)),
                ('last_update', models.DateField(auto_now=True)),
                ('account_balance', models.IntegerField(default=0)),
                ('fee_override', models.IntegerField(blank=True, default=None, null=True)),
                ('fee_registration_paid', models.BooleanField(default=False)),
                ('comment', models.CharField(blank=True, max_length=255)),
                ('erfa', models.ForeignKey(default=members.models.get_alien, on_delete=django.db.models.deletion.CASCADE, to='members.Erfa')),
            ],
            options={
                'manager_inheritance_from_future': True,
            },
            bases=('members.person',),
        ),
        migrations.CreateModel(
            name='Subscriber',
            fields=[
                ('person_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='members.Person')),
                ('subscriber_source', models.CharField(choices=[('UKS', 'UNKNOWN SOURCE'), ('SYN', 'INITIAL IMPORT')], max_length=3)),
                ('max_datenschleuder_issue', models.IntegerField(default=0)),
                ('is_endless', models.BooleanField(default=False)),
                ('rt_link', models.URLField(blank=True, default='', max_length=60, null=True)),
            ],
            options={
                'manager_inheritance_from_future': True,
            },
            bases=('members.person',),
        ),
        migrations.AddField(
            model_name='person',
            name='polymorphic_ctype',
            field=models.ForeignKey(editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='polymorphic_members.person_set+', to='contenttypes.ContentType'),
        ),
        migrations.RunPython(forward, backward),
        migrations.DeleteModel(name='Member'),
        migrations.RenameModel(old_name='Member_new', new_name='Member'),
        migrations.RenameField(
            model_name='emailaddress',
            old_name='member',
            new_name='person',
        ),
        migrations.AlterUniqueTogether(
            name='emailaddress',
            unique_together=set([('person', 'email_address')]),
        ),
        migrations.AlterField(
            model_name='emailaddress',
            name='person',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='members.Person'),
        ),
    ]

    if global_apps.is_installed('datenschleuder'):
        dependencies.append(('datenschleuder', '0002_auto_20180404_1641'))
